﻿<!------------------------------------>
<!-- 아래 목록은 php 파일에도 똑같이 정의했다 -->
<!------------------------------------>
var __dsm_admin_mode = 1; // {0, 1}
var __dsm_result_state_new_rec__ = "DSM-NEW_REC:";
var __dsm_result_state_summary_text__ = "DSM-SUMMARY_TEXT:";
var __dsm_result_state_summary_text_len__ = "DSM-SUMMARY_TEXT_LEN:";
var __dsm_result_state_summary_ING__ = "DSM-SUMMARY_ING:";
var __dsm_result_state_headword__ = "DSM-HEADWORD:";
var __dsm_result_state_wordlist__ = "DSM-WORDLIST:";
var __dsm_result_state_error__ = "Error:";
var __dsm_result_state_update_rec_state__ = "DSM-UPDATE_REC:";
var __dsm_result_state_finish__ = "DSM-FINISH:";
var __dsm_command_summary_do__ = "DsmProcessing";
var __dsm_command_summary_text__ = "DsmSummaryText";
var __dsm_command_summary_pause__ = "DsmSummaryPause";
var __dsm_command_summary_wording__  = "DsmWording";
var __dsm_command_summary_wordlist__ = "DsmWordList";
var __dsm_command_wording_pause__ = "DsmWordingPause";
var __dsm_command_finish_summary__ = "DsmFinishSummary";
var __dsm_command_finish_wording__ = "DsmFinishWording";
var __dsm_text_min_limit__ = 128;
var __dsm_text_max_limit__ = 3800;
if(__dsm_admin_mode == 1) {
    __dsm_text_max_limit__ = 13800;
}
var __dsm_rate_bytes_sign__ = 'b';
var __dsm_rate_percent_sign__ = 'p';

var __dsm_result_field_delimiter = '-^*-.-_^_^_-.-*^-';   

var __dsm_msg_warn_text_short__ = 'warn: it can not need to summarize because of short text.';
var __dsm_msg_warn_text_long__ = 'warn: it can not summarize because of long text.';

/*
var __msg_search_guide = '주제어를 입력하세요.';

//----- var keyword_sep = "---";
var keyword_sep = " ";
var result_rec_kwd_delimiter = "-^-._.-^._.^-._.-^-";
var chart_name_1 = "tgxchart1";
*/
<!------------------------------------>
<!------------------------------------>

// 아래 부분은 자바스크립트에만 있는 변수
var dsm_result_no = "no summary result.";
var dsm_result_error = "error in summarizing.";
var dsm_result_retry = "try again after 1 minitues.";
var dsm_result_time_over = dsm_result_retry;
var dsm_summarizing_ing = "summarizing... wait...";
var dsm_timer_id = 0;
//-var dsm_timer_interval = 1000; // 1 second
var dsm_timer_interval = 2000; // 1 second
//-var dsm_timer_interval = 3000; // 1 second
//-var dsm_resuls_timer_wait_max = (30 * 1000); // 30 second
var dsm_resuls_timer_wait_max = (45 * 1000); // 45 second
//-var dsm_resuls_timer_wait_max = (60 * 1000); // 60 second
//-var dsm_resuls_timer_wait_max = (10 * 1000); // 10 second
var dsm_resuls_timer_counter = 0;

var __dsm_result_word_delimiter = '\r\n';
var __dsm_result_word_feq_delimiter = '\t';

var dsm_wording_dict = []; // array 

function focusInput (x)
{
    //- x.style.background = 'yellow';
    x.value = '';
}

function getCharCount(strBf, compChar)
{
    var charNum = 0;

    if((strBf == undefined) || (compChar == undefined)) {
        return charNum;
    }
    
    for(var i = 0; i < strBf.length; i++) {
        if(strBf.charAt(i) == compChar) {
            charNum++;
        }
    }
    //--- alert('lf num :' + charNum);
    return charNum;
}

function getNewRecID(strBf)
{
    var RecID = 0;

    if(strBf == undefined) {
        return RecID;
    }

    var NewRecID_Pos = strBf.indexOf(__dsm_result_state_new_rec__);
    if(NewRecID_Pos < 0) {
        return RecID;
    }
    var NewRecID_Str = strBf.slice( NewRecID_Pos + __dsm_result_state_new_rec__.length);
    NewRecID_Str = NewRecID_Str.replace("\r\n", "");
    //-NewRecID_Str = NewRecID_Str.replace("\r", "");
    RecID = NewRecID_Str.replace("\n", "");
    //-alert('RecID :' + RecID + ' (' + RecID.length + ')');
    
    return RecID;
}

function _mysql_real_escape_string (strBf) 
{
    return strBf.replace(/[\0\x08\x09\x1a\n\r"'\\\%]/g, function (char) 
    {
        switch (char) {
            case "\0":
                return "\\0";
            case "\x08":
                return "\\b";
            case "\x09":
                return "\\t";
            case "\x1a":
                return "\\z";
            case "\n":
                return "\\n";
            case "\r":
                return "\\r";
            case "\"":
            case "'":
            case "\\":
            case "%":
                return "\\"+char; // prepends a backslash to backslash, percent, and double/single quotes
        }
    });
}

function getSummaryKeyValue(strBf, key)
{
    var keyValue = "";

    if(strBf == undefined) {
        return keyValue;
    }

    var Find_Pos = strBf.indexOf(key);
    if(Find_Pos < 0) {
        return keyValue;
    }
    keyValue = strBf.slice(Find_Pos + key.length);
    if(keyValue.length >= 2) {
        // 내부적으로 추가된 맨 뒤에 "\r\n" 길이를 지운다.
        keyValue = keyValue.slice(0, -2);
    } 
    //--- console.log('keyValue :' + keyValue);
    return keyValue;
}

function copy_clipboard(copyText) {
    window.prompt("Copy to clipboard: Ctrl+C / Cmd+C, Enter", copyText);
}

function move_progbar(pos) {
    var ProgBar = document.getElementById('DsmProgressBar');
    ProgBarWidth = Math.round(pos);
    if(ProgBarWidth > 100) {
        ProgBarWidth = 100;
    }
    else if(ProgBarWidth < 0) {
        ProgBarWidth = 0;
    }
    ProgBar.style.width = ProgBarWidth + '%';
    document.getElementById("DsmProgressLabel").innerHTML = Math.round(ProgBarWidth) + '%';    
}

function dsmFinish(dsmCommand)
{
    //-----
    var tpx_command = dsmCommand;
    var dsm_InputID = document.getElementById('dsm-id').value;

    //----- 
    //----- 
    var tpx_dsm_InputID = '&DsmID=' + encodeURIComponent(_mysql_real_escape_string(dsm_InputID));
    var newData = 'action=' + tpx_command + tpx_dsm_InputID;
    //--- console.log(newData);

    //-----    
    //-----
    var xhttp;
    var command = __d_knl_commad__;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            console.log(xhttp.responseText + '\r\n');
            var result_msg;
            if(xhttp.responseText.indexOf(__dsm_result_state_error__) >= 0) {
                //
            }
            else if(xhttp.responseText.indexOf(__dsm_result_state_finish__) >= 0) {
                //
            }
            else {
                // 
            }
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);   

    //
    return false;
}

