﻿var __d_knl_commad__ = 'd-knl_processing.php?';

function dsmRun() 
{
    // 홈페이지에서 요약을 기다리는 중간에 (리프레시 없이) [요약]버튼을 또 다시 누르면 타이머가 2개 이상 동작하게 된다.
    // 그래서 [요약]버튼을 누르면 무조건 타이머를 꺼야 한다.
    timer_stop_summary();
    dsm_resuls_timer_counter = 1;
    
    //-----
    var tpx_command = __dsm_command_summary_do__;
    var dsm_originText = '';

    //-----
    dsm_originText = document.getElementById('dsm_originText').value;
    if(dsm_originText.length <  __dsm_text_min_limit__) {
        alert(__dsm_msg_warn_text_short__ + '\n' + dsm_originText.length + ' < ' +  __dsm_text_min_limit__);
        return;
    }
    else if(dsm_originText.length > __dsm_text_max_limit__) {
        alert(__dsm_msg_warn_text_long__ + '\n' + dsm_originText.length + ' > ' +  __dsm_text_max_limit__);
        return;
    }
    
    //-----
    var dsm_InputRate = document.getElementById('dsm_InputRate').value;
    var dsm_rate_pos = dsm_InputRate.indexOf(__dsm_rate_bytes_sign__);
    var dsm_rate_value = 0;
    if(dsm_rate_pos >= 0) { // byte unit
        dsm_rate_value = dsm_InputRate.slice(0, dsm_rate_pos);
        if( dsm_rate_value >= dsm_originText.length) {
            alert(__dsm_msg_warn_text_short__ + '\n' + dsm_originText.length  + ' <= ' + dsm_rate_value);
            return;
        }
    }
    else {
        dsm_rate_pos = dsm_InputRate.indexOf(__dsm_rate_percent_sign__);
        if(dsm_rate_pos >= 0) { // percent unit
            var dsm_rate_value_per = dsm_InputRate.slice(0, dsm_rate_pos);
            dsm_rate_value = (dsm_originText.length * dsm_rate_value_per) / 100;
        }
        else {
            alert('error: summary rate value');
            return;
        }        
    }
    //--- alert(dsm_rate_value);

    //-----
    var dsm_InputHeadwordNum = document.getElementById('dsm_InputHeadwordNum').value;

    //----- 
    //----- 
    var tpx_dsm_originText = '&DsmText=' + encodeURIComponent(_mysql_real_escape_string(dsm_originText));
    var tpx_dsm_InputRate = '&DsmRate=' + encodeURIComponent(_mysql_real_escape_string(dsm_InputRate));
    var tpx_dsm_originText_char_num = '&DsmTextCharNum=' + encodeURIComponent(dsm_originText.length);
    var tpx_dsm_InputHeadwordNum = '&DsmHeadwordNum=' + encodeURIComponent(_mysql_real_escape_string(dsm_InputHeadwordNum));
    var newData = 'action=' + tpx_command + tpx_dsm_InputRate + tpx_dsm_originText_char_num + 
                    tpx_dsm_InputHeadwordNum + tpx_dsm_originText;
    //--- alert(newData);

    //----- ui-proc
    var innerTxt = dsm_originText.length + ' (chars)'
    document.getElementById('dsm_originTextLen').hidden = false;
    document.getElementById('dsm_originTextLen').innerText = innerTxt;
    document.getElementById('dsm_summaryTextLen').hidden = true;
    document.getElementById('feed-headword').hidden = true;

    //-----    
    //-----
    var xhttp;
    var command = __d_knl_commad__;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //-alert(xhttp.responseText);
            console.log(xhttp.responseText);
            //--- document.getElementById('feedback').innerHTML = xhttp.responseText;
            var result_msg;
            if(getCharCount(xhttp.responseText, '\n') >= 2) {
                //--------------------
                //----- 개행문자 '1'는 http 규약으로 무조건 포함해서 온다.
                //----- 결과가 없으면 개행 문자가 '1'개다.
                //--------------------
                if(xhttp.responseText.indexOf(__dsm_result_state_error__) >= 0) {
                    result_msg = dsm_result_error;
                }
                else {
                    var newRecID = getNewRecID(xhttp.responseText);
                    document.getElementById('dsm-id').value = newRecID;
                    result_msg = dsm_summarizing_ing;
                    timer_start_summary();
                }
            }
            else {
                result_msg = dsm_result_no;
            }
            document.getElementById('feed-summary').hidden = false;
            document.getElementById('dsm_summaryText').value = result_msg;
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);   

    //
    return false;
}

function getDsmSummary() 
{
    // pre-init-ui
    document.getElementById('dsm_summaryTextLen').hidden = true;
    document.getElementById('feed-headword').hidden = true;

    //
    var newData = '';
    var tpx_command = __dsm_command_summary_text__;

    //-----
    var dsm_InputID = document.getElementById('dsm-id').value;
    var tpx_dsm_InputID = '&DsmID=' + encodeURIComponent(_mysql_real_escape_string(dsm_InputID));

    // time-check
    dsm_resuls_timer_counter++;
    var time_check = dsm_resuls_timer_counter * dsm_timer_interval;
    console.log('time-check: (' + dsm_resuls_timer_counter + ') ' + time_check);
    if(time_check >= dsm_resuls_timer_wait_max) {
        timer_stop_summary(); // summary-reponse-over-time: stop-timer
        document.getElementById('feed-summary').hidden = false;
        document.getElementById('dsm_summaryText').value = dsm_result_time_over;

        // 더 이상 요약할 필요가 없다고 알려준다.
        tpx_command = __dsm_command_summary_pause__;
    }
    newData = 'action=' + tpx_command + tpx_dsm_InputID;
    //-alert(newData);

    //-----
    var xhttp;
    var command = __d_knl_commad__;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //--- console.log(xhttp.responseText);
            if(time_check >= dsm_resuls_timer_wait_max) {
                return; // timer-over
            }

            var responseList = xhttp.responseText.split(__dsm_result_field_delimiter);
            //--- console.log(responseList);

            var dsmHeadword = '', innerTxt = '', innerHtm = '';
            var summaryByteLen = 0;
            var result_msg = '';
            var isAlreadySearch;
            for(var i = 0; i < responseList.length; i++) {
                isAlreadySearch = responseList[i].indexOf(__dsm_result_state_error__);
                if(isAlreadySearch >= 0) {
                    result_msg = dsm_result_error;
                    timer_stop_summary(); // error: stop-timer
                    break;
                }

                isAlreadySearch = responseList[i].indexOf(__dsm_result_state_summary_ING__);
                if(isAlreadySearch >= 0) {
                    // 아직 진행 중이므로 계속 타이머를 돌아야 한다.
                    result_msg = dsm_summarizing_ing;
                    break;
                }

                isAlreadySearch = responseList[i].indexOf(__dsm_result_state_summary_text_len__);
                if(isAlreadySearch >= 0) {
                    summaryByteLen = getSummaryKeyValue(responseList[i], __dsm_result_state_summary_text_len__);
                }

                isAlreadySearch = responseList[i].indexOf(__dsm_result_state_headword__);
                if(isAlreadySearch >= 0) {
                    dsmHeadword = getSummaryKeyValue(responseList[i], __dsm_result_state_headword__);
                }

                isAlreadySearch = responseList[i].indexOf(__dsm_result_state_summary_text__);
                if(isAlreadySearch >= 0) {
                    timer_stop_summary(); // finish: stop-timer
                    dsmFinish(__dsm_command_finish_summary__);                                

                    var SummaryText = getSummaryKeyValue(responseList[i], __dsm_result_state_summary_text__);
                    if(SummaryText.length <= 0) {
                        // 오류가 아니라 요약 내용이 없는 경우
                        result_msg = SummaryText;
                    }
                    else { // 요약 내용이 있는 경우
                        result_msg = SummaryText;
                        innerTxt = result_msg.length + ' (chars)'
                        if(summaryByteLen > 0) {
                            innerTxt += (' / ' + summaryByteLen + ' (bytes)');
                        }
                        document.getElementById('dsm_summaryTextLen').hidden = false;                        
                        document.getElementById('dsm_summaryTextLen').innerText = innerTxt;

                        //-----
                        //-----
                        var headwordList = dsmHeadword.split(__dsm_result_word_delimiter);
                        var headword_num = 0;
                        for(var headcnt = 0; headcnt < headwordList.length; headcnt++) {
                            if(headwordList[headcnt].length == 0) { // __dsm_result_word_delimiter만 있고 내용이 없는 경우 - 맨 뒤에 추가 붙는 것이 있다.
                                continue;
                            }
                            var oneItem = headwordList[headcnt];
                            oneItem = oneItem.trim();
                            if(oneItem.length <= 0) {
                                continue;
                            }

                            //
                            var oneWord = oneItem.split(__dsm_result_word_feq_delimiter);
                            if(oneWord.length <= 1) {
                                continue;
                            }
                            var wordValue = oneWord[0].trim();
                            //-var wordFreq = oneWord[1].trim();
                            
                            if(headword_num == 0) {
                                innerHtm = wordValue;
                            }
                            else {
                                if((headword_num % 10) == 0) {
                                    innerHtm += ',<br>' + wordValue;
                                }
                                else {
                                    if(headword_num < (headwordList.length - 1)) { // 맨 마지막은 구문문자 ',' 넣지 않는다.
                                        innerHtm += ', ' + wordValue;
                                    }
                                }
                            }                            
                            headword_num++;
                        }           
                        if(innerHtm.length > 0) {
                            //--- console.log(innerHtm);
                            document.getElementById('feed-headword').hidden = false;
                            document.getElementById('headword-list').innerHTML = innerHtm;

                            innerTxt = headword_num + ' (words)'
                            document.getElementById('dsm_headword_num').innerText = innerTxt;
                        }
                        else {
                            console.log('no headword');
                        }             
                    }
                    break;
                }
            }
            if(responseList.length <= 0) {
                result_msg = dsm_result_no;
                timer_stop_summary();  // error: stop-timer
            }
            document.getElementById('feed-summary').hidden = false;
            document.getElementById('dsm_summaryText').value = result_msg;
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);   

    //
    return false;
}

function copy_summary_text() {
    var summaryText = document.getElementById('dsm_summaryText').value;
    copy_clipboard(summaryText);
}

function select_summary_text() {
    document.getElementById('dsm_summaryText').focus();
    document.getElementById('dsm_summaryText').select();
}

function copy_headword() {
    var tmpTxt = document.getElementById('headword-list').innerHTML;
    var copyText = tmpTxt.replace(/<br>/g, ' '); // 핵심어를 출력할때 일정 간격으로 줄바꿈을 넣어뒀기 때문에 빼서 보여줘야 한다. 
    copy_clipboard(copyText);
}

function timer_stop_summary() {
    if(dsm_timer_id != 0) {
        clearInterval(dsm_timer_id); // finish: stop-timer
    }
    dsm_timer_id = 0;
}

function timer_start_summary() {
    timer_stop_summary();
    dsm_timer_id = setInterval(getDsmSummary,  dsm_timer_interval);
}

function eraseDsmText()
{
    document.getElementById('dsm_originText').value = "";
}