﻿var __d_knl_commad__ = 'd-knl_processing.php?';
var stoplist_user_data = [];
var stoplist_data = [];
var mergelist_data = [];
var wordlist_data = [];

var stoplist_article = ['a', 'an', 'A', 'An',  'AN', 'the', 'The', 'THE'];
var stoplist_pronoun = [
                        //-'Me', 'We', 'Our', 'He', 'His', 'They', 'Their', 'It', 'Anyone', 'Nobody', 'What', 'Who', 'You',          
                        'I', 'me', 'my', 'myself', 'mine', 
                        'we', 'our', 'ours', 'ourselves',
                        'he', 'his', 'him', 'himself',
                        'she', 'her', 'hers', 'herself',
                        'it', 'its', 'itself', 
                        'they', 'their', 'them', 'themselves',
                        'this', 'that', 'these', 'those',  
                        'all', 'another', 'any', 'anybody', 'anyone',
                        'both', 'each', 'either','everybody', 'everyone',
                        'few', 'many', 'most', 'neither', 'nobody', 'none',
                        'no', 'one', 'one\'s', 'other', 'some', 'somebody', 'someone',
                        'anything', 'everything', 'something', 
                        'such',
                        'what', 'when', 'who', 'whose', 'why', 'we', 'which', 
                        'you', 'your', 'yours', 'yourself',  'yourselves'
                        ]; 
var stoplist_preposition = [
                        //-'For', 'About',  
                        'about', 'after', 'against', 'around', 'at', 'away', '',  
                        'before', 'between', 'by',
                        'down', 'during',
                        'except',  
                        'for', 'from', 
                        'in', 'into', 
                        'of', 'off', 'on', 'over', 'out',
                        'to', 'toward', 'through',   
                        'under', 'up', 'upon',
                        'with', 'within', 'without'
                        ];
var stoplist_auxverb = ['are', 'is', 'be', 'being', 
                        'can', 'could', 'do', 'doing', 'done', 'have', 'has',
                        'may', 'might', 'must', 
                        'shall', 'will', 'would', 'should'
                        ];
var stoplist_conjunction = [
                        'and', 'also', 'although', 'as', 
                        'because', 'but', 
                        'despite',
                        'hence', 'however',
                        'if', 
                        'nevertheless', 
                        'or',
                        'since',
                        'than', 'therefore', 'though', 'thus', 'too',
                        'unless', 'unlike', 'until',
                        'whether', 'while',
                        'yet'
                        ];
var stoplist_adverb = [
                        //-'How', 
                        'again', 'ago', 'almost', 'already', 'also', 'always', 'away', 
                        'back', 'before',
                        'else', 'even', 'ever',  
                        'here','how', 
                        'just',
                        'more', 'much',  
                        'never', 'no', 'not', 'now',  
                        'often', 'only', 'over',
                        'perhaps',
                        'rather',  
                        'so', 'sometimes', 'soon', 
                        'there', 'today', 'tomorrow',   
                        'usually',
                        'very',
                        'where', 
                        'yes', 'yesterday'   
                        ];

function timer_stop_wordlist() {
    if(dsm_timer_id != 0) {
        clearInterval(dsm_timer_id); // finish: stop-timer
    }
    dsm_timer_id = 0;
}

function timer_start_wordlist() {
    timer_stop_wordlist();
    dsm_timer_id = setInterval(getDwdWordList,  dsm_timer_interval);
}

function dsmWord()
{
    // 홈페이지에서 요약을 기다리는 중간에 (리프레시 없이) [요약]버튼을 또 다시 누르면 타이머가 2개 이상 동작하게 된다.
    // 그래서 [요약]버튼을 누르면 무조건 타이머를 꺼야 한다.
    timer_stop_wordlist();
    dsm_resuls_timer_counter = 1;
    move_progbar(0);

    //
    document.getElementById('word-list').innerHTML = "";
    document.getElementById('feed-sort').hidden = true;
    if(document.getElementById('DsmProgress').hidden == true) {
        document.getElementById('DsmProgress').hidden = false;
    }
    
    //-----
    var tpx_command = __dsm_command_summary_wording__;
    var dsm_originText = '';

    //-----
    dsm_originText = document.getElementById('dsm_originText').value;
    if(dsm_originText.length <  __dsm_text_min_limit__) {
        alert(__dsm_msg_warn_text_short__ + '\n' + dsm_originText.length + ' < ' +  __dsm_text_min_limit__);
        return;
    }
    else if(dsm_originText.length > __dsm_text_max_limit__) {
        alert(__dsm_msg_warn_text_long__ + '\n' + dsm_originText.length + ' > ' +  __dsm_text_max_limit__);
        return;
    }

    //----- init dict
    mergelist_data = [];
    stoplist_data = [];
    stoplist_user_data = [];
    
    //-----
    var dsm_wordnum = document.getElementById('dsm_wordnum').value;
    var dsm_InputID = document.getElementById('dsm-id').value;

    //----- 
    //----- 
    var tpx_dsm_originText = '&DsmText=' + encodeURIComponent(_mysql_real_escape_string(dsm_originText));
    var tpx_dsm_InputID = '&DsmID=' + encodeURIComponent(_mysql_real_escape_string(dsm_InputID));
    var tpx_dsm_wordnum = '&DsmWordNum=' + encodeURIComponent(_mysql_real_escape_string(dsm_wordnum));
    var tpx_dsm_originText_char_num = '&DsmTextCharNum=' + encodeURIComponent(dsm_originText.length);
    var newData = 'action=' + tpx_command + tpx_dsm_wordnum + tpx_dsm_InputID + 
                    tpx_dsm_originText_char_num + tpx_dsm_originText;
    //--- console.log(newData);

    //----- ui-proc
    var innerTxt = dsm_originText.length + ' (chars)'
    document.getElementById('dsm_originTextLen').hidden = false;
    document.getElementById('dsm_originTextLen').innerText = innerTxt;
    document.getElementById('feed-word').hidden = true;

    //-----    
    //-----
    var xhttp;
    var command = __d_knl_commad__;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            console.log(xhttp.responseText + '\r\n');
            //--- document.getElementById('feedback').innerHTML = xhttp.responseText;
            var result_msg;
            if(xhttp.responseText.indexOf(__dsm_result_state_error__) >= 0) {
                result_msg = dsm_result_error;
            }
            else if(xhttp.responseText.indexOf(__dsm_result_state_new_rec__) >= 0) {
                var newRecID = getNewRecID(xhttp.responseText);
                document.getElementById('dsm-id').value = newRecID;
                result_msg = dsm_summarizing_ing;
                timer_start_wordlist();
            }
            else {
                result_msg = dsm_result_no;
            }
            document.getElementById('feed-word').hidden = false;
            document.getElementById('feed-wordlist').innerHTML = result_msg;
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);   

    //
    return false;
}

function getDwdWordList() 
{
    // pre-init-ui

    //
    var newData = '';
    var result_msg = '';
    var tpx_command = __dsm_command_summary_wordlist__;

    //-----
    var dsm_InputID = document.getElementById('dsm-id').value;
    var tpx_dsm_InputID = '&DsmID=' + encodeURIComponent(_mysql_real_escape_string(dsm_InputID));

    // time-check
    prog_bar_hide = true;
    dsm_resuls_timer_counter++;
    var time_check = dsm_resuls_timer_counter * dsm_timer_interval;
    console.log('time-check: (' + dsm_resuls_timer_counter + ') ' + time_check);
    if(time_check >= dsm_resuls_timer_wait_max) {
        timer_stop_wordlist(); // summary-reponse-over-time: stop-timer
        //-document.getElementById('word-list').hidden = false;
        result_msg = dsm_result_time_over; // timer-over

        // 더 이상 요약할 필요가 없다고 알려준다.
        tpx_command = __dsm_command_wording_pause__;
    }
    var ProgBarPos  = ((time_check * 100) / dsm_resuls_timer_wait_max);
    move_progbar(ProgBarPos);
    
    newData = 'action=' + tpx_command + tpx_dsm_InputID;
    //-alert(newData);

    //-----
    var xhttp;
    var command = __d_knl_commad__;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //--- console.log(xhttp.responseText);
            if((time_check >= dsm_resuls_timer_wait_max) ||
                (tpx_command == __dsm_command_wording_pause__)) {
                result_msg = dsm_result_time_over; // timer-over
            }
            else {
                var responseList = xhttp.responseText.split(__dsm_result_field_delimiter);
                //--- console.log(responseList);

                var dsmHeadword = '', innerTxt = '', innerHtm = '';
                var isAlreadySearch;
                for(var i = 0; i < responseList.length; i++) {
                    isAlreadySearch = responseList[i].indexOf(__dsm_result_state_error__);
                    if(isAlreadySearch >= 0) {
                        result_msg = dsm_result_error;
                        timer_stop_wordlist(); // error: stop-timer
                        break;
                    }

                    isAlreadySearch = responseList[i].indexOf(__dsm_result_state_summary_ING__);
                    if(isAlreadySearch >= 0) {
                        // 아직 진행 중이므로 계속 타이머를 돌아야 한다.
                        result_msg = dsm_summarizing_ing;
                        prog_bar_hide = false;
                        break;
                    }

                    isAlreadySearch = responseList[i].indexOf(__dsm_result_state_wordlist__);
                    if(isAlreadySearch >= 0) {
                        timer_stop_wordlist(); // finish: stop-timer
                        var WordListReponse = getSummaryKeyValue(responseList[i], __dsm_result_state_wordlist__);
                        if(WordListReponse.length <= 0) {
                            // 오류가 아니라 요약 내용이 없는 경우
                            result_msg = WordListReponse;
                        }
                        else { // 요약 내용이 있는 경우
                            var word_num = transWordList(WordListReponse);
                            if(word_num <= 0) {
                                // [wordlist]값이 없는 경우인데, 논리적인 오류일 때만 발생한다.
                                console.log('no word');
                                result_msg = dsm_result_no;
                            }
                            else {
                                document.getElementById('dsm_wordsort').selectedIndex = '2'; // frequnecy
                                document.getElementById('dsm_wordkey').selectedIndex = '0'; // key(all)
                                stopword_filtering();
                                sendWordDict();
                                
                                //
                                dsmFinish(__dsm_command_finish_wording__);                                
                            }             
                        }
                        break;
                    }
                }
                if(responseList.length <= 0) {
                    result_msg = dsm_result_no;
                    timer_stop_wordlist();  // error: stop-timer
                }
            }
            if(prog_bar_hide == true) {
                document.getElementById('DsmProgress').hidden = true;
            }
            document.getElementById('feed-wordlist').hidden = false;
            document.getElementById('feed-wordlist').innerHTML = result_msg;
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);   

    //
    return false;
}

function transWordList(WordListSeries)
{
    // init-reset
    dsm_wording_dict = []; // array 
    
    //
    var wordList = WordListSeries.split(__dsm_result_word_delimiter);
    var word_num = 0;
    var word_mod = 1;
    for(var word_cnt = 0; word_cnt < wordList.length; word_cnt++) {
        if(wordList[word_cnt].length == 0) { // __dsm_result_word_delimiter만 있고 내용이 없는 경우 - 맨 뒤에 추가 붙는 것이 있다.
            continue;
        }
        var oneItem = wordList[word_cnt];
        oneItem = oneItem.trim();
        if(oneItem.length <= 0) {
            continue;
        }

        //
        var oneWord = oneItem.split(__dsm_result_word_feq_delimiter);
        if(oneWord.length <= 1) {
            continue;
        }
        var wordValue = oneWord[0].trim();
        var wordFreq = oneWord[1].trim();
        
        //
        word_num++;

        //      
        var worditem = {word:wordValue, freq:wordFreq};
        dsm_wording_dict.push(worditem);
    }
    dsm_wording_dict.sort(); // order by abc 

    return word_num;
}

function sendWordDict()
{
    transWordDict();
    printWordDict();
}

var _Base64_ = {
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    encode: function(input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = _Base64_._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },


    decode: function(input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = _Base64_._utf8_decode(output);

        return output;

    },

    _utf8_encode: function(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    _utf8_decode: function(utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}

function clickStopwordDict(fileAddress)
{
    //
    stoplist_user_data = []; // reset

    //
    var r = new FileReader(); 
    var file = document.getElementById('stop_user').files[0];
    r.onload = function() {
        //-console.log('file size = ' + r.result.length + '\r\n'); 
        //-console.log(r.result + '\r\n'); 
        var readDataBase64 = r.result;
        readDataBase64 = readDataBase64.slice(23); // del header 23 char {data:text/plain;base64,}
        var readData = _Base64_.decode(readDataBase64);
        //-console.log(readData);

        //
        readData = readData.replace(/\r\n/g, "\n"); // {\r\n} -> {\n}
        user_data_array = readData.split('\n');
        for(var cnt = 0; cnt < user_data_array.length; cnt++) {
            var stopword = user_data_array[cnt];
            stopword.trim();
            if(stopword.length <= 0) {
                continue;
            }
            stoplist_user_data.push(stopword);
            //
            add_stoplist(stopword);
        }
        make_stopword_tag();

        // 불용어 파일을 읽고 나면 파일명을 지워줘야 한다.
        // 그렇지 않고 (내용을 변경하고) 다시 같은 파일을 선택하면 
        // 변경된 내용이 없다고 판단해서 이 함수로 들어오지 않는다.
        // 반드시 파일명을 지워준 후에 파일이 선택되어야 이 함수로 온다.
        document.getElementById('stop_user').value = '';
        return;
    }
    if(file == undefined) { // 파일 선택을 취소한 경우 - 사용자 사전을 초기화로 간주
        return;
    }
    r.readAsDataURL(file); // [BASE64 format]
    return;
}

function readServerTextFile(textfile)
{
    var rawFile = new XMLHttpRequest();
    rawFile.open("GET", textfile, false);
    rawFile.onreadystatechange = function ()
    {
        if(rawFile.readyState === 4) {
            if(rawFile.status === 200 || rawFile.status == 0) {
                console.log(rawFile.responseText);
            }
        }
    }
    rawFile.send(null);
}

function isNumber(num) {
    return !isNaN(parseFloat(num)) && isFinite(num);
}

function isNumberExtend(num)
{   // 숫자와 기호 조합: 1.0  3:2
    var num_flag = false;
    var sign_flag = false;
    for(var cnt = 0; cnt < num.length; cnt++) {
        var onechar = num.charAt(cnt);
        switch(onechar) {
        case '0':   case '1':   case '2':   case '3':   case '4':
        case '5':   case '6':   case '7':   case '8':case '9':
        //
        case 0: case 1: case 2: case 3: case 4:
        case 5: case 6: case 7: case 8:case 9:
            num_flag = true;
            break;
        case ':':   case '.':   case ',':   case '/':
            sign_flag = true;
            break;
        default:
            return false;
        }
    }
    if((num_flag == true) && (sign_flag == true)) {
        return true;
    }
    return false;
}

function stopword_opt_click()
{
    stopword_btn_click();
    update_stoplist_check_state();
    sendWordDict();
}

function stopword_opt()
{
    // merge-word-area 켜 있으면 끈다.
    if(document.getElementById('mergeword_opt_area').hidden == false) {
        document.getElementById('mergeword_opt_area').hidden = true;        
        document.getElementById('mergeword_opt_btn').hidden = false;
    }

    //
    document.getElementById('stopword_opt_area').hidden = false;
    document.getElementById('stopword_opt_btn').hidden = true;
    document.getElementById('dsm_wordsort').disabled = true;
}

function stopword_btn_click() 
{
    document.getElementById('stopword_opt_area').hidden = true;
    document.getElementById('stopword_opt_btn').hidden = false;
    document.getElementById('dsm_wordsort').disabled = false;
}

function mergeword_opt()
{
    // stop-word-area 켜 있으면 끈다.
    if(document.getElementById('stopword_opt_area').hidden == false) {
        document.getElementById('stopword_opt_area').hidden = true;        
        document.getElementById('stopword_opt_btn').hidden = false;
    }

    //
    document.getElementById('mergeword_opt_area').hidden = false;
    document.getElementById('mergeword_opt_btn').hidden = true;
    document.getElementById('dsm_wordsort').disabled = true;
}

function mergeword_opt_click()
{
    mergeword_btn_click();
    sendWordDict();
}

function mergeword_btn_click() 
{
    document.getElementById('mergeword_opt_area').hidden = true;
    document.getElementById('mergeword_opt_btn').hidden = false;
    document.getElementById('dsm_wordsort').disabled = false;
}

function copy_wording_dict() 
{
    var copy_wording_dict = [];
    for(var cnt = 0; cnt < dsm_wording_dict.length; cnt++) {
        var worditem_org = dsm_wording_dict[cnt];
        var worditem_new = {word:worditem_org['word'], freq:worditem_org['freq']};
        copy_wording_dict.push(worditem_new);
    }
    return copy_wording_dict;
}

function mergeword_caps_click()
{
    //
    var merge_wording_dict = copy_wording_dict();

    //
    var dispNum = 0;
    for(var word_num = 0; word_num < merge_wording_dict.length; word_num++) {
        var worditem = merge_wording_dict[word_num];
        var wordValue = worditem['word'];
        var wordFreq = worditem['freq'];

        // merge-check
        var wordValue_new = wordValue.toLowerCase();
        if((wordValue_new.length == wordValue.length) &&
            (wordValue_new.localeCompare(wordValue) != 0)) {
            add_mergelist(wordValue, wordValue_new, wordFreq);
        }
    }
    //
    make_mergeword_tag();
}

function mergelist_data_check(mergelist_data_order)
{
    if(mergelist_data_order == 0) {
        var tmpVar = 'mergelist_data_check_' + mergelist_data_order;
        var check_state = document.getElementById(tmpVar).checked;

        var dispNum = 1;
        for(var cnt = 0; cnt < mergelist_data.length; cnt++, dispNum++) {
            var tmpVar = 'mergelist_data_check_' + dispNum;
            document.getElementById(tmpVar).checked = check_state;
        }
    }
}

function transMergeList()
{
    //
    var tmpVar, check_state; 
    var dispNum = 1;
    for(var cnt = 0; cnt < mergelist_data.length; cnt++, dispNum++) {
        tmpVar = 'mergelist_data_check_' + dispNum;
        check_state = document.getElementById(tmpVar).checked;
        if(check_state == false) { // 체크 표시가 없는 것은 mergelist_data에서 제외
            mergelist_data[cnt].check = false;
        }
    }

    //
    var merge_wording_dict = copy_wording_dict();

    //
    var dispNum = 0;
    for(var word_num = 0; word_num < mergelist_data.length; word_num++) {
        if(mergelist_data[word_num].check == false) { // 바꿀 필요가 없는 경우
            continue;
        }
        //
        var worditem = mergelist_data[word_num];
        var wordValue = worditem['word'];
        var wordReplace = worditem['replace'];
        var wordFreq = worditem['freq'];
        //-var wordCheck = worditem['check'];

        // merge-check
        var show_freq; 
        var repPos = merge_wording_dict.map(function(x) {return x.word; }).indexOf(wordReplace);
        if(repPos >= 0) { // 대치 단어가 있는 경우 - 빈도수를 통합해준다.
            var worditem_org = merge_wording_dict[repPos];
            show_freq = Number(worditem_org['freq']) + Number(wordFreq); // 소문자에 빈도를 합산한다.
            merge_wording_dict[repPos].freq = show_freq;
            //-console.log('[plus]' + wordValue_new + ' : ' + merge_wording_dict[repPos].freq);
        }
        else { // 대치 단어가 없는 경우 - 대치 단어를 추가한다.
            var worditem_replace = {word:wordReplace, freq:wordFreq};
            merge_wording_dict.push(worditem_replace); // 소문자에 빈도를 합산한다.
            //-console.log('[add]' + wordValue_new + ' : ' +worditem_replace.freq);
        }

        // 원래 단어를 지운다.
        var originPos = merge_wording_dict.map(function(x) {return x.word; }).indexOf(wordValue);
        if(originPos < 0) {
            alert('logical-error');
        }
        else {
            merge_wording_dict.splice(originPos, 1);
        }
    }

    //-console.log(merge_wording_dict);
    return merge_wording_dict;
}

function make_mergeword_tag()
{
    //
    mergelist_data.sort(function(a, b) {
        var ret_val = a.word.localeCompare(b.word);
        return ret_val;
    });

    //
    document.getElementById('merge_list_area').innerHTML = '';

    //
    var mergelist_data_tag = '';
    var dispNum = 0;
    for(var cnt = 0; cnt < mergelist_data.length; cnt++) {
        var worditem = mergelist_data[cnt];
        var wordValue = worditem['word'];
        var wordReplace = worditem['replace'];
        var wordFreq = worditem['freq'];
        var wordCheck = worditem['check'];

        var replaceCheckTag = ' ';
        if(wordCheck == true) {
            replaceCheckTag = ' checked ';
        }
        
        if(dispNum == 0) {
            mergelist_data_tag  = "<table id='WordlistTable'>" + 
                        "<tr class='header'>" +
                        "<th style='width:9%;'>" + "<input type='checkbox' id='mergelist_data_check_" + 
                            dispNum + "' checked onclick='mergelist_data_check(" + dispNum + ")'>" + "</th>" + 
                        "<th style='width:9%;'></th>" +
                        "<th style='width:40%;'>Word</th>" +
                        "<th style='width:2%;'></th>" +
                        "<th style='width:40%;'>Relace</th>" +
                        "</tr>";
        }
        dispNum++;
        mergelist_data_tag += "<tr>" + 
                "<td>" + "<input type='checkbox' id='mergelist_data_check_" + dispNum + 
                "' " + replaceCheckTag + "onclick='mergelist_data_check(" + dispNum + ")'>" + "</td>" + 
                "<td>" + dispNum + "</td>" + 
                "<td>" + wordValue + "</td>" + 
                "<td>" + "</td>" + 
                "<td>" + wordReplace + "</td>" + 
                "</tr>";
    }
    if(mergelist_data_tag.length > 0) {
        mergelist_data_tag += '</table>';
        mergelist_data_tag += '<br>'; // 테두리 겹치지 않게 1줄 더 준다.
    }
    document.getElementById('merge_list_area').innerHTML = mergelist_data_tag;
}

function clickMergeDictFile(fileAddress)
{
    //
    var r = new FileReader(); 
    var file = document.getElementById('merge_user').files[0];
    r.onload = function() {
        //-console.log('file size = ' + r.result.length + '\r\n'); 
        //-console.log(r.result + '\r\n'); 
        var readDataBase64 = r.result;
        readDataBase64 = readDataBase64.slice(23); // del header 23 char {data:text/plain;base64,}
        var readData = _Base64_.decode(readDataBase64);
        //-console.log(readData);

        //
        readData = readData.replace(/\r\n/g, "\n"); // {\r\n} -> {\n}
        user_data_array = readData.split('\n');
        for(var cnt = 0; cnt < user_data_array.length; cnt++) {
            var mergeword = user_data_array[cnt];
            mergeword.trim();
            if(mergeword.length <= 0) {
                continue;
            }

            //
            mergeword_item = mergeword.split('->');
            if(mergeword_item.length == 2) {
                var mergeword_origin = mergeword_item[0];
                var mergeword_replace = mergeword_item[1];
                mergeword_origin.trim();
                mergeword_replace.trim();
                if((mergeword_origin.length <= 0) || (mergeword_replace.length <= 0)) {
                    continue;
                }

                //
                add_mergelist(mergeword_origin, mergeword_replace);
            }
        }
        //
        make_mergeword_tag();
        return;
    }
    if(file == undefined) { // 파일 선택을 취소한 경우 - 사용자 사전을 초기화로 간주
        return;
    }
    r.readAsDataURL(file); // [BASE64 format]
    return;
}

function add_mergelist(wordvalue, replaceword, wordfreq)
{
    var wordPos;

    // 빈도 확인
    var newfreq = 0;
    if(wordfreq == undefined) { // 단어 빈도가 없으면 찾아야 한다.
        wordPos = dsm_wording_dict.map(function(x) {return x.word;}).indexOf(wordvalue);
        if(wordPos <= 0) {
            alert('logical-error');
            return;
        }
        newfreq = dsm_wording_dict[wordPos].freq;
    }
    else {
        newfreq = wordfreq;
    }

    //
    var show_freq; 
    var replacePos = dsm_wording_dict.map(function(x) {return x.word;}).indexOf(replaceword);
    if(replacePos >= 0) {
        var repalce_freq = dsm_wording_dict[replacePos].freq;
        show_freq = Number(repalce_freq) + Number(newfreq); // 소문자에 빈도를 합산한다.
    }
    else { // 소문자형을 추가한다.
        show_freq = newfreq;
    }

    // 이미 통합 목록에 등록되었나 확인
    wordPos = mergelist_data.map(function(x) {return x.word;}).indexOf(wordvalue);
    if(wordPos < 0) {
        var worditem_new = {word:wordvalue, 
                            replace:replaceword, 
                            freq:show_freq, 
                            check:true
                            };
        mergelist_data.push(worditem_new);
    }
}

function stopword_filtering()
{
    //
    var wording_dict = copy_wording_dict();

    //
    var stop_article = document.getElementById('stop_article').checked;
    var stop_preposition = document.getElementById('stop_preposition').checked;
    var stop_pronoun = document.getElementById('stop_pronoun').checked;
    var stop_auxverb = document.getElementById('stop_auxverb').checked;
    var stop_conjunction = document.getElementById('stop_conjunction').checked;
    var stop_adverb = document.getElementById('stop_adverb').checked;
    var stop_number = document.getElementById('stop_number').checked;
    var stop_number_add = document.getElementById('stop_number_add').checked; // 0.1  1:2
    
    //
    for(var word_num = 0; word_num < wording_dict.length; word_num++) {
        var worditem = wording_dict[word_num];
        var wordValue = worditem["word"];
        var wordFreq = worditem["freq"];

        // filter
        var stop_state = false;
        if(stop_article == true) {
            if(stoplist_article.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stop_preposition == true) {
            if(stoplist_preposition.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stop_pronoun == true) {
            if(stoplist_pronoun.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stop_auxverb == true) {
            if(stoplist_auxverb.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stop_conjunction == true) {
            if(stoplist_conjunction.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stop_adverb == true) {
            if(stoplist_adverb.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stoplist_user_data.length > 0) {
            if(stoplist_user_data.indexOf(wordValue) >= 0) {
                stop_state = true;
            }
        }
        if(stop_number == true) {
            if(Number(wordValue) == wordValue) {
                stop_state = true;
            }
        } 
        if(stop_number_add == true) {
            if(isNumberExtend(wordValue) == true) {
                stop_state = true;
            }
        } 
        if(stop_state == false) {
            check_stoplist(wordValue, false);
            continue;
        }

        // 
        add_stoplist(wordValue);
    }           

    //
    make_stopword_tag();
}

function add_stoplist(wordvalue)
{
    // 이미 통합 목록에 등록되었나 확인
    var wordPos = stoplist_data.map(function(x) {return x.word;}).indexOf(wordvalue);
    if(wordPos < 0) {
        var worditem_new = {word:wordvalue, check:true};
        stoplist_data.push(worditem_new);
    }
    else { // 이미 등록되어 있으면 [stopword]로 사용하겠다로 체크표시
        stoplist_data[wordPos].check = true;
    }
}

function del_stoplist(wordvalue)
{
    // 이미 통합 목록에 등록되었나 확인
    var wordPos = stoplist_data.map(function(x) {return x.word;}).indexOf(wordvalue);
    if(wordPos >= 0) {
        stoplist_data.splice(wordPos, 1);
    }
}

function check_stoplist(wordvalue, check)
{
    // 이미 통합 목록에 등록되었나 확인
    var wordPos = stoplist_data.map(function(x) {return x.word;}).indexOf(wordvalue);
    if(wordPos >= 0) {
        stoplist_data[wordPos].check = check;
    }
}

function make_stopword_tag()
{
    //
    stoplist_data.sort(function(a, b) {
        var ret_val = a.word.localeCompare(b.word);
        return ret_val;
    });

    //
    document.getElementById('stopword_list_area').innerHTML = '';

    //
    var stoplist_data_tag = '';
    var dispNum = 0;
    for(var cnt = 0; cnt < stoplist_data.length; cnt++) {
        var worditem = stoplist_data[cnt];
        var wordValue = worditem['word'];
        var wordCheck = worditem['check'];

        var CheckTag = ' ';
        if(wordCheck == true) {
            CheckTag = ' checked ';
        }
        
        if(dispNum == 0) {
            stoplist_data_tag  = "<table id='WordlistTable'>" + 
                        "<tr class='header'>" +
                        "<th style='width:9%;'>" + "<input type='checkbox' id='stoplist_data_check_" + 
                            dispNum + "' checked onclick='stoplist_data_check(" + dispNum + ")'>" + "</th>" + 
                        "<th style='width:9%;'></th>" +
                        "<th >Word</th>" +
                        "</tr>";
        }
        dispNum++;
        stoplist_data_tag += "<tr>" + 
                "<td>" + "<input type='checkbox' id='stoplist_data_check_" + dispNum + 
                "' " + CheckTag + "onclick='stoplist_data_check(" + dispNum + ")'>" + "</td>" + 
                "<td>" + dispNum + "</td>" + 
                "<td>" + wordValue + "</td>" + 
                "</tr>";
    }
    if(stoplist_data_tag.length > 0) {
        stoplist_data_tag += '</table>';
        stoplist_data_tag += '<br>'; // 테두리 겹치지 않게 1줄 더 준다.
    }
    document.getElementById('stopword_list_area').innerHTML = stoplist_data_tag;
}

function update_stoplist_check_state()
{
    //
    var dispNum = 0;
    for(var cnt = 0; cnt < stoplist_data.length; cnt++) {
        dispNum++;
        stoplist_data_check(dispNum);
    }
}

function stoplist_data_check(stoplist_data_order)
{
    var tmpVar, check_state;
    if(stoplist_data_order == 0) {
        tmpVar = 'stoplist_data_check_' + stoplist_data_order;
        check_state = document.getElementById(tmpVar).checked;

        var dispNum = 1;
        for(var cnt = 0; cnt < stoplist_data.length; cnt++, dispNum++) {
            var tmpVar = 'stoplist_data_check_' + dispNum;
            document.getElementById(tmpVar).checked = check_state;

            stoplist_data[cnt].check = check_state;
        }
    }
    else {
        tmpVar = 'stoplist_data_check_' + stoplist_data_order;
        check_state = document.getElementById(tmpVar).checked;
        var tmpNum = Number(stoplist_data_order) - 1; // order_1_base -> index_zero_base
        stoplist_data[tmpNum].check = check_state;
    }
}

function keyword_filtering(wordvalue, dsm_wordkey)
{
    if(dsm_wordkey == 'key') {
        return true;
    }
    if(dsm_wordkey == 'capital') {
        var wordValue_new = wordvalue.toLowerCase();
        if((wordValue_new.length == wordvalue.length) &&
            (wordValue_new.localeCompare(wordvalue) != 0)) {
            return true;
        }
        else {
            return false;
        }
    }
    //
    if(wordvalue.length <= dsm_wordkey.length) {
        return false;
    }

    //
    var retval = false;
    var filter_word, check_word, slice_len;
    if(dsm_wordkey.charAt(0) == '-') { // tail-find
        filter_word = dsm_wordkey.slice(1);
        slice_len = wordvalue.length - filter_word.length;
        check_word = wordvalue.slice(slice_len);
        if(check_word == filter_word) {
            retval = true;
        }
    }
    else if(dsm_wordkey.charAt(dsm_wordkey.length - 1) == '-') { // head-find
        slice_len = (dsm_wordkey.length - 1);
        filter_word = dsm_wordkey.slice(0, slice_len);
        check_word = wordvalue.slice(0, slice_len);
        if(check_word == filter_word) {
            retval = true;
        }
    }
    else { // logcal-error, send true
        retval =  true;
    }
    return retval;
}

function transWordDict()
{
    //
    wordlist_data = transMergeList();

    var dsm_wordsort = document.getElementById('dsm_wordsort').value;
    if(dsm_wordsort == 'a') {
        wordlist_data.sort(function(a, b) {
            var ret_val = a.word.localeCompare(b.word);
            return ret_val;
        });
    }
    else if(dsm_wordsort == 'z') {
        wordlist_data.sort(function(a, b) {
            var ret_val = a.word.localeCompare(b.word);
            if(ret_val < 0) {
                ret_val = 1;
            }
            else if(ret_val > 0) {
                ret_val = -1;
            }
            return ret_val;
        });
    }
    else if(dsm_wordsort == 'f') {
        wordlist_data.sort(function(a, b) { 
            var ret_val = b.freq - a.freq; // 빈도높은순
            if(ret_val == 0) { // 빈도 같으면
                ret_val = a.word.localeCompare(b.word); // 사전순
            }
            return ret_val;
        });
    }
    else {
        alert('logic-error : ' + 'sort');
        return;
    }

    //
    var dsm_wordkey  = document.getElementById('dsm_wordkey').value;
    var dispNum = 0;
    var word_num = 0;     
    while(word_num < wordlist_data.length) {
        var worditem = wordlist_data[word_num];
        var wordValue = worditem["word"];
        var wordFreq = worditem["freq"];

        // filter
        var wordPos = stoplist_data.map(function(x) {return x.word;}).indexOf(wordValue);
        if(wordPos >= 0) {
            if(stoplist_data[wordPos].check == true) {
                wordlist_data.splice(word_num, 1); // delete current
                continue;
            }
        }
        var keyword_flag = keyword_filtering(wordValue, dsm_wordkey);
        if(keyword_flag == false) {
            wordlist_data.splice(word_num, 1); // delete current
            continue;
        }

        //
        dispNum++;
        word_num++;
    }           
    //-console.log(wordlist_data);
    return dispNum;
}

function printWordDict()
{
    //
    var innerHtm  = "<table id='WordlistTable'>" + 
                "<tr class='header'>" +
                "<th style='width:10%;'></th>" +
                "<th style='width:60%;'>Word</th>" +
                "<th style='width:30%;'>Count</th>" +
                "</tr>";
    
    //
    var dispNum = 0;    
    for(var word_num = 0; word_num < wordlist_data.length; word_num++) {
        var worditem = wordlist_data[word_num];
        var wordValue = worditem["word"];
        var wordFreq = worditem["freq"];

        //
        dispNum++;
        innerHtm += "<tr>" + 
                    "<td>" + dispNum + "</td>" + 
                    "<td>" + wordValue + "</td>" + 
                    "<td>" + wordFreq + "</td>" + 
                    "</tr>";
    }           
    innerHtm += "</table>";                                    
    //-console.log(innerHtm);

    document.getElementById('feed-sort').hidden = false;
    document.getElementById('word-list').hidden = false;
    document.getElementById('word-list').innerHTML = innerHtm;
    
    innerTxt = dispNum + ' (words)';
    document.getElementById('dsm_wordlist_num').hidden = false;
    document.getElementById('dsm_wordlist_num').innerText = innerTxt;

    return dispNum;
}

function make_dsm_wordle()
{
    var wordcloud_data = 'fruitbats:133' +  String.fromCharCode(13) +  String.fromCharCode(10) +   
                    'llamas on parade:85.43' + String.fromCharCode(13) +  String.fromCharCode(10) +
                    'zombies?:420' + String.fromCharCode(13) +  String.fromCharCode(10);
    var wordcloud_list = ' ';
    for(var word_num = 0; word_num < wordlist_data.length; word_num++) {
        var worditem = wordlist_data[word_num];
        var wordValue = worditem["word"];
        var wordFreq = worditem["freq"];

        //
        var wordcloud_item = wordValue + ':' + wordFreq + '\r\n'; 
        if(word_num == 0) {
            wordcloud_list = wordcloud_item; 
        }
        else {
            wordcloud_list += wordcloud_item; 
        }
    }           
    //-console.log(wordcloud_list);

    //----- 
    var command = 'http://www.wordle.net/compose';

    var form = document.createElement("form");
    form.setAttribute("method", "post");
    form.setAttribute("action", command);
    form.setAttribute("target", "_blank");

    var hiddenField = document.createElement("textarea");      
    hiddenField.setAttribute("name", "wordcounts");
    hiddenField.setAttribute("id", "wordcounts");
    hiddenField.rows = 4;
    hiddenField.cols = 80;
    hiddenField.value = wordcloud_list;
    hiddenField.hidden = true;
    form.appendChild(hiddenField);
    document.body.appendChild(form);

    form.submit();    
}

function copy_wordlist(exclude_numbering)
{
    var wordcloud_list = ' ';
    for(var word_num = 0; word_num < wordlist_data.length; word_num++) {
        var worditem = wordlist_data[word_num];
        var wordValue = worditem["word"];
        var wordFreq = worditem["freq"];

        //
        var wordcloud_item = wordValue + ':' + wordFreq + '\r\n';  // {단어,빈도}로 출력할 때는 ':'으로 필드 구분(단어구름용)

        //
        if((exclude_numbering == undefined) || (exclude_numbering == '1')) {
            // 출력 순서 제외 - 아무 것도 처리하지 않는다.
        }
        else { // 출력 순서 포함
            var disp_number = (word_num + 1);
            wordcloud_list += disp_number.toString() + '\t'; // 출력순서를 표시할 경우에는 'tab'으로 필드 구분
            wordcloud_item = wordValue + '\t' + wordFreq + '\r\n';  // 출력순서를 표시할 경우에는 'tab'으로 필드 구분
        }
        wordcloud_list += wordcloud_item; 
    }           
    //-console.log(wordcloud_list);

    //----- 
    copy_clipboard(wordcloud_list);
}

